diff --git a/CHANGELOG b/CHANGELOG
index ccac516..b11ca75 100644
--- a/CHANGELOG
+++ b/CHANGELOG
@@ -36,6 +36,7 @@
 - check kernel module version and require 5.00 or above.
 - fix expire regression introduced in the "mitigate manual umount" patch.
 - still more on multiply recursive bind mounts.
+- fix tokenizer to distinguish between global option and dn string.
 
 1/9/2006 autofs-5.0.1 rc2
 -------------------------
diff --git a/lib/master_tok.l b/lib/master_tok.l
index cf90136..71d8c26 100644
--- a/lib/master_tok.l
+++ b/lib/master_tok.l
@@ -148,6 +148,13 @@ OPTTOUT		(-t{OPTWS}|-t{OPTWS}={OPTWS}|--
 		return(PATH);
 	}
 
+	{WS}/{DNATTRSTR}= {
+		BEGIN(MAPSTR);
+		*bptr = '\0';
+		strcpy(master_lval.strtype, buff);
+		return(PATH);
+	}
+
 	{WS}/"-" {
 		BEGIN(OPTSTR);
 		*bptr = '\0';
@@ -156,6 +163,14 @@ OPTTOUT		(-t{OPTWS}|-t{OPTWS}={OPTWS}|--
 		return(PATH);
 	}
 
+	{WS}/{OPTIONSTR} {
+		BEGIN(OPTSTR);
+		*bptr = '\0';
+		strcpy(master_lval.strtype, buff);
+		bptr = buff;
+		return(PATH);
+	}
+
 	\\.  { *bptr++ = *(master_text + 1); }
 	\"   {
 		BEGIN(INITIAL);
diff --git a/modules/parse_sun.c b/modules/parse_sun.c
index 9847ea9..6f10a4f 100644
--- a/modules/parse_sun.c
+++ b/modules/parse_sun.c
@@ -349,12 +349,12 @@ int parse_init(int argc, const char *con
 				return 1;
 			}
 			ctxt->optstr = noptstr;
-			debug(LOGOPT_NONE,
-			      MODPREFIX "init gathered options: %s",
-			      ctxt->optstr);
 		}
 	}
 
+	debug(LOGOPT_NONE,
+	      MODPREFIX "init gathered global options: %s", ctxt->optstr);
+
 	/* We only need this once.  NFS mounts are so common that we cache
 	   this module. */
 	if (!mount_nfs) {
